Subject: bug#76978: [PATCH] package.el: Add built-in version check and loaded package marking

From: david <[email-masked]>
Date: Wed, 19 Mar 2025 07:54:32 -0400

Stefan Monnier <[email-masked]> writes:
>
> [...] I do think we want to show which packages are "activated" (or
> "active").
>
I agree.  Using "activated," as initially proposed, seems to be the more
appropriate choice.

I will proceed to update the patch based on the latest suggestions and
feedback.  Below is an example of how the changes would appear in
`describe-package`:

Package marginalia is installed.

     Status: Installed in ‘marginalia-2.0/’. Delete
    Version: 2.0
     Commit: c51fd9e4d4258543e0cd8dedda941789163bec5a
     ...
Other versions: 1.8 (installed), 2.0 (gnu, activated), 20250317.1632 (melpa).

Package diff-hl is installed.

     Status: Installed in ‘diff-hl-1.10.0/’. Delete
    Version: 1.10.0
     Commit: b80ff9b4a772f7ea000e86fbf88175104ddf9557
     ...
Other versions: 1.10.0 (gnu, activated), 20250317.242 (melpa).

Package track-changes is installed.

     Status: Installed in ‘track-changes-1.4/’. Delete
    Version: 1.4
     Commit: ffb7d656a2c89f86ccd2de51379de9612c7a4aa3
     ...
Other versions: 1.4 (gnu, activated), 1.2 (built-in).

Package faceup is installed.

     Status: Installed in ‘faceup-20170925.1946/’,
             shadowing a built-in package (unsigned). Delete
    Version: 20170925.1946
     Commit: 6c92dad56a133e14e7b27831e1bcf9b3a71ff154
     ...
Other versions: 20170925.1946 (melpa, activated), 0.0.6 (built-in).

Note on the package "faceup."  It is interesting that a built-in
package, when installed via `package-install` and with MELPA added to
`package-archives`, can update to a version from MELPA (no GNU ELPA
version is available for this package).

> [...] please contact the FSF clerk and ask them to add the email you
> use habitually (such as the one I'm replying to) to avoid such
> problems in the future.
>
Will do. Thanks.